Adobe interview experience Real time questions & tips from candidates to crack your interview

SDE - Intern

Adobe
upvote
share-icon
3 rounds | 6 Coding problems

Interview preparation journey

expand-icon
Preparation
Duration: 7-8 months
Topics: Data Structures , Operating System, OOPS ,JAVA, projects , Memory allocation in C
Tip
Tip

Tip 1 : You should have in depth knowledge of your projects. Sometimes Adobe spend a whole interview in project discussion (in some cases).
Tip 2 : OOPS is a very important subject if you are preparing for Adobe. Also one should know real life examples of it and should be able to code any concept of it.
Tip 3 : One should have good knowledge of data structures. Mainly Array, Math, Tree, Recursion and LinkedList.
Tip 4 : According to me , projects just play role if you applying off campus and that too for the shortlisting of your resume as it gives you an edge in respect to other candidates. So if you are applying off campus you should have atleast 2-3 good projects in you resume.

Application process
Where: Campus
Eligibility: 70% in UG, 60% in 12th and 10th
Resume Tip
Resume tip

Tip 1 : One should have good projects.
Tip 2 : The presentation of your resume should be really good. Bold keywords like tech stack you used or the topics you are really good at.

Interview rounds

01
Round
Easy
Online Coding Interview
Duration70 minutes
Interview date19 Oct 2020
Coding problem2

Timing : 11:00 am
Webcam was mandatory.

1. Missing Numbers

Easy
28m average time
85% success
0/40
Asked in companies
GoogleAdobeOla

You are given an array 'ARR' of distinct positive integers. You need to find all numbers that are in the range of the elements of the array, but not in the array. The missing elements should be printed in sorted order.

Example:
If the given array is [4, 2, 9] then you should print "3 5 6 7 8". As all these elements lie in the range but not present in the array.
Problem approach

I just run a loop from 1 till N 

Try solving now

2. Prime with 3 factors

Moderate
25m average time
80% success
0/80
Asked in companies
CognizantAdobeCiti Bank

You are given an array ‘ARR’ consisting of ‘N’ positive integers. Your task is to find if the number has exactly 3 factors for each number in the array ‘ARR’.

You have to return an array consisting of ‘0,’ and ‘1’ where ‘0’ means that ‘ARR[index]’ does not have 3 factors and ‘1’ means ‘ARR[index]’ has exactly 3 factors.

For Example:
If ‘N’ = 4 and ‘ARR’ = [3, 5, 4, 2]. 
3 has 2 factors, which are 1 and 3.
5 has 2 factors, which are 1 and 5.
4 has 3 factors, which are  1, 2 and 4.
2 has 2 factors, which are 1 and 2.
Hence, the answer is [0, 0, 1, 0].
Problem approach

Step 1 : While n is divisible by 2, print 2 and divide n by 2.
Step 2 :  After step 1, n must be odd. Now start a loop from i = 3 to square root of n. While i divides n, print i and divide n by i. After i fails to divide n, increment i by 2 and continue.
Step 3 : If n is a prime number and is greater than 2, then n will not become 1 by above two steps. So print n if it is greater than 2.

Try solving now
02
Round
Medium
Online Coding Interview
Duration108 minutes
Interview date30 Oct 2020
Coding problem2

Timing : 10:00 am
Webcam was mandatory

1. Rat In a Maze All Paths

Moderate
40m average time
60% success
0/80
Asked in companies
VisaExpedia GroupHexaware Technologies

You are given a 'N' * 'N' maze with a rat placed at 'MAZE[0][0]'. Find and print all paths that rat can follow to reach its destination i.e. 'MAZE['N' - 1]['N' - 1]'. Rat can move in any direc­tion ( left, right, up and down).

Value of every cell in the 'MAZE' can either be 0 or 1. Cells with value 0 are blocked means the rat can­not enter into those cells and those with value 1 are open.

Problem approach

I wrote a solution using Dynamic Programming.
Step 1 : initialize a 2 D matrix and assign a meaning to value (here in our case , possible paths from given point to bottom right corner)
Step 2 : I initialized the matrix using base cases (if one column or one row)
Step 3 : filled the matrix accordingly.

Try solving now

2. Min jumps

Easy
15m average time
85% success
0/40
Asked in companies
IBMAmerican ExpressSamsung R&D Institute

You live in a Ninja town which is in the form of a N * M grid. In this town, people travel from one place to another by jumping over the buildings which are present in each cell of the grid. It is Christmas eve, and Santa wants to give gifts and chocolates to the kids who live in the building which is present at the cell (N - 1, M - 1). Initially, Santa is present on cell (0, 0). Since Santa is in a hurry, help him find a path from starting point to the endpoint with the least amount of time.

The Santa may go only from one building to any of its adjacent buildings which is present either to the right or to the bottom or bottom right cell i.e. if the current position is (x, y), he may go to (x + 1, y + 1) or (x + 1, y) or (x, y + 1) given that the new coordinates are in the grid. The time taken to reach from one building to another is equal to the absolute difference between the heights of buildings.

Note:

1. The heights of the buildings are positive.
2. Santa starts from the cell (0, 0) and he has to reach the building (N - 1, M - 1).
3. Santa cannot leave the grid at any point of time.
Problem approach

I used Dynamic programing.
Step 1 : initialized a 1-D array
Step 2 : initialized last index value to zero.
Step 3 : calculated minimum steps from n-2 index to n-1 index and till index = 0

Try solving now
03
Round
Medium
Video Call
Duration70 minutes
Interview date17 Dec 2020
Coding problem2

Timing : 5 pm
Camera and mic was mandatory.
The interviewer was really nice and adjustable.

1. Count distinct substrings

Moderate
10m average time
90% success
0/80
Asked in companies
Paytm (One97 Communications Limited)AdobeAmazon

Given a string 'S', you are supposed to return the number of distinct substrings(including empty substring) of the given string. You should implement the program using a trie.

Note :
A string ‘B’ is a substring of a string ‘A’ if ‘B’ that can be obtained by deletion of, several characters(possibly none) from the start of ‘A’ and several characters(possibly none) from the end of ‘A’. 

Two strings ‘X’ and ‘Y’ are considered different if there is at least one index ‘i’  such that the character of ‘X’ at index ‘i’ is different from the character of ‘Y’ at index ‘i’(X[i]!=Y[i]).
Problem approach

Step 1 : I used something similar to sliding window algorithm
Step 2 : I called a function which contains starting index of the string , an empty StringBuilder as it is mutable and an Arraylist to store indexes of all valid substrings as parameters.
Step 3 : declared a base case which states that the whole string is traversed.
Step 4 : declared some conditions,
(a) if the output String does not matches the length of the substring then append the character in output string (here output string is the StringBuilder we passed as parameter).
(b) if the length of output String got matched with given substring then compare the output string with substring.
if its matches then calculate its starting index and add it in the list.
and lastly remove first character from output string and add character at current index in output string and call the function recursively to check all the occurrences.

Try solving now

2. Zigzag Binary Tree Traversal

Easy
10m average time
90% success
0/40
Asked in companies
Goldman SachsAmazon

You are given a ‘Binary Tree’.


Return the level-order traversal of the Binary Tree.


Example:
Input: Consider the following Binary Tree:

Example

Output: 
Following is the level-order traversal of the given Binary Tree: [1, 2, 3, 5, 6, 4]


Problem approach

I kept an counter to calculate the level and and performed level order traversal and applied a condition that if the level was odd I added the elements into the list in reverse order fashion.

Try solving now

Here's your problem of the day

Solving this problem will increase your chance to get selected in this company

Skill covered: Programming

Which operator is used for exponentiation in Python?

Choose another skill to practice
Similar interview experiences
company logo
SDE - Intern
1 rounds | 7 problems
Interviewed by Adobe
1302 views
0 comments
0 upvotes
company logo
SDE - Intern
2 rounds | 4 problems
Interviewed by Adobe
745 views
0 comments
0 upvotes
company logo
SDE - Intern
2 rounds | 2 problems
Interviewed by Adobe
853 views
0 comments
0 upvotes
company logo
SDE - Intern
2 rounds | 4 problems
Interviewed by Adobe
642 views
0 comments
0 upvotes
Companies with similar interview experiences
company logo
SDE - Intern
3 rounds | 6 problems
Interviewed by Amazon
13855 views
4 comments
0 upvotes
company logo
SDE - Intern
4 rounds | 7 problems
Interviewed by Microsoft
13095 views
1 comments
0 upvotes
company logo
SDE - Intern
2 rounds | 4 problems
Interviewed by Amazon
9196 views
2 comments
0 upvotes